unit UFDarsteller;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, GLOBAL, GERD, UFDarstellerHinzufuegen, clipbrd, LCLType;

type
  TFDarsteller = class(TForm)
    Li: TListBox;
    tesuchbegriff: TEdit;
    buAkt: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure tesuchbegriffChange(Sender: TObject);
    procedure buAktClick(Sender: TObject);
    procedure LiKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure LiDblClick(Sender: TObject);
    procedure LiKeyPress(Sender: TObject; var Key: Char);
    procedure buAktMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    dateiname : ansistring;
    fensterpos : trect;
    aktiv : boolean;
    procedure anzahl;
    procedure einlesen;
    procedure speichern;
  end;

var
  FDarsteller: TFDarsteller;

implementation

uses UFHaupt;

{$R *.lfm}

procedure TFDarsteller.anzahl;

begin
     if   fileexists (dateiname)
     then caption := 'Darstellerliste (' + inttostr (li.items.count) + ' Einträge)'
     else caption := 'Darstellerliste (leer)';
end;




procedure TFDarsteller.einlesen;

begin
     if   fileexists (dateiname) then
     begin
          li.items.LoadFromFile (dateiname);
          li.itemindex := 0;
          caption := 'Darstellerliste (' + inttostr (li.items.count) + ' Einträge)';
     end else
     begin
          li.items.clear;
          li.itemindex := -1;
          caption := 'Darstellerliste (leer)';
     end;

     anzahl;
end;




procedure TFDarsteller.speichern;

begin
     if   li.items.Count > 0
     then li.items.SaveToFile (dateiname);
end;




procedure TFDarsteller.FormShow(Sender: TObject);
begin
     dateiname := extractfilepath (application.exename) + 'Darsteller.txt';
     einlesen;
end;

procedure TFDarsteller.FormHide(Sender: TObject);
begin
     speichern;

     if   aktiv then
     begin
          fhaupt.boundsrect := fensterpos;
          aktiv := false;
     end;
end;

procedure TFDarsteller.tesuchbegriffChange(Sender: TObject);

var
     j : integer;

begin
     if   li.items.count = 0
     then exit;

     for  j := 0 to pred (li.items.count)
     do   if   pos (tsuppercase (tesuchbegriff.text), tsuppercase (li.items [j])) = 1 then
          begin
               li.itemindex := j;
               break;
          end;

end;

procedure TFDarsteller.buAktClick(Sender: TObject);

var
     j, p : integer;
     h, s : string;

begin
     sanduhr1;
     FDarstellerHinzufuegen.li.items.clear;

     for  j := 1 to filesize (frec) do
     begin
          lesen (j);
          s := rec.Darsteller;
          p := pos (';', s);

          while p > 0 do
          begin
               h := trim (copy (s, 1, pred (p)));

               if   (h > '')
               and  (li.Items.IndexOf (h) = -1)
               and  (FDarstellerHinzufuegen.li.items.indexof (h) = -1)
               then FDarstellerHinzufuegen.hinzufuegen (h);

               delete (s, 1, succ (p));
               p := pos (';', s);
          end;
     end;

     sanduhr0;
     FDarstellerHinzufuegen.left := left + width + 10;
     FDarstellerHinzufuegen.top := top;
     FDarstellerHinzufuegen.showmodal;
end;

procedure TFDarsteller.LiKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
     if   key = vk_delete
     then li.items.Delete (li.itemindex);

     anzahl;
end;

procedure TFDarsteller.LiDblClick(Sender: TObject);
begin
     clipboard.AsText := '"' + li.items [li.itemindex] + '"';
end;

procedure TFDarsteller.LiKeyPress(Sender: TObject; var Key: Char);
begin
     if   key = ' '
     then lidblclick (self);
end;

procedure TFDarsteller.buAktMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if   button <> mbright
     then exit;

     if   aktiv then
     begin
          fhaupt.boundsrect := fensterpos;
          aktiv := false;
     end else
     begin
          fensterpos := fhaupt.boundsrect;
          fhaupt.left := screen.width + 10;
          aktiv := true;
     end;
end;

end.

