unit UFDateilisten;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, GLOBAL, GERD, ExtCtrls;

type
  TFDateilisten = class(TForm)
    Label1: TLabel;
    teListenverz: TEdit;
    Button1: TButton;
    Label2: TLabel;
    gbFilmlisten: TGroupBox;
    cbTitel: TCheckBox;
    cbGenre: TCheckBox;
    cbJahr: TCheckBox;
    cbFormat: TCheckBox;
    cbDatum: TCheckBox;
    cbStempel: TCheckBox;
    buOK: TButton;
    buAbbruch: TButton;
    teDateiname: TEdit;
    LiNamen: TComboBox;
    Label3: TLabel;
    cbdetail: TCheckBox;
    Shape1: TShape;
    cbCDNr: TCheckBox;
    procedure buAbbruchClick(Sender: TObject);
    procedure buOKClick(Sender: TObject);
    procedure cbTitelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LiNamenChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure akt;
  end;

var
  FDateilisten: TFDateilisten;

implementation

{$R *.lfm}

procedure TFDateilisten.akt;

var
     h : string;

begin
     h := linamen.text;

     if   cbstempel.checked
     then h := h + ' vom ' + formatdatetime ('DD.MM.YYYY - HH:NN', now);

     if   cbtitel.checked
     or   cbgenre.checked
     or   cbjahr.checked
     or   cbformat.checked
     or   cbcdnr.checked
     or   cbdatum.checked
     then h := h + ' (sortiert nach XYZ)';

     if   cbdetail.checked
     then h := h + ' (detailliert)';

     tedateiname.text := h;
end;




procedure TFDateilisten.buAbbruchClick(Sender: TObject);
begin
     modalresult := mrcancel;
end;

procedure TFDateilisten.buOKClick(Sender: TObject);
begin
     // Alle Werte für die INI übernehmen
     us.listen.titel     := cbtitel  .checked;
     us.listen.genre     := cbgenre  .checked;
     us.listen.jahr      := cbjahr   .checked;
     us.listen.datum     := cbdatum  .checked;
     us.listen.cdnr      := cbcdnr   .checked;
     us.listen.stempel   := cbstempel.checked;
     us.listen.detail    := cbdetail .checked;
     us.listen.dateiname := linamen     .text;
     us.listen.verz      := telistenverz.text;
     linamen.text := trim (linamen.text);

     if   linamen.text <> ''
     then if   linamen.items.indexof (linamen.text) = -1
          then linamen.items.add (linamen.text);

     us.listen.namen.assign (linamen.items);

     modalresult := mrok;
end;

procedure TFDateilisten.cbTitelClick(Sender: TObject);
begin
     akt;
end;

procedure TFDateilisten.FormShow(Sender: TObject);
begin
     // Alte Einstellungen zuweisen
     cbtitel  .checked := us.listen.titel;
     cbgenre  .checked := us.listen.genre;
     cbjahr   .checked := us.listen.jahr;
     cbdatum  .checked := us.listen.datum;
     cbcdnr   .checked := us.listen.cdnr;
     cbstempel.checked := us.listen.stempel;
     cbdetail .checked := us.listen.detail;

     linamen     .text := us.listen.dateiname;
     telistenverz.text := us.listen.verz;

     if   telistenverz.text = ''
     then telistenverz.text := progverz;

     linamen.items.Assign (us.listen.namen);
     akt;
end;

procedure TFDateilisten.LiNamenChange(Sender: TObject);
begin
     akt;
end;

procedure TFDateilisten.Button1Click(Sender: TObject);

var
     dir : string;

begin
     dir := telistenverz.text;

     if   not selectdirectory (dir, [], 0)
     then exit;

     telistenverz.text := verz_mit_slash (dir);
end;

end.

