unit UFHinzufuegen;

interface

uses
  Messages , SysUtils , Classes , dbf , mysql55conn , sqldb , db , Graphics ,
  Controls , Forms , Dialogs , LCLType , StdCtrls , Spin , global , GERD ,
  ExtCtrls;

type

  { TFHinzufuegen }

  TFHinzufuegen = class(TForm)
    buOK: TButton;
    buAbbruch: TButton;
    Label3: TLabel;
    liFormat: TComboBox;
    Label2: TLabel;
    teDatum: TEdit;
    Label4: TLabel;
    teJahr: TEdit;
    Label5: TLabel;
    teTitel: TEdit;
    Label6: TLabel;
    meInfo: TMemo;
    buImportieren: TButton;
    teBemerkung: TEdit;
    Label7: TLabel;
    Dlg: TOpenDialog;
    buDatum: TButton;
    Label9: TLabel;
    teGenre: TEdit;
    Label11: TLabel;
    teHDName: TEdit;
    buAutomatisch: TButton;
    laInfogroesse: TLabel;
    tiWarnung: TTimer;
    Timer1: TTimer;
    procedure buAbbruchClick(Sender: TObject);
    procedure buOKClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure FormShow(Sender: TObject);
    procedure buImportierenClick(Sender: TObject);
    procedure buDatumClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure buAutomatischClick(Sender: TObject);
    procedure meInfoChange(Sender: TObject);
    procedure tiWarnungTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    ID : integer;
    procedure ausfuellen;
    function verzeichnis_groesse (v : string) : int64;
  end;

var
  FHinzufuegen: TFHinzufuegen;

implementation

uses UFHaupt;

{$R *.lfm}
procedure TFHinzufuegen.FormDropFiles(Sender: TObject; const FileNames: array of String);

var
     dropname : pchar; // Die Datei bzw. Verzeichnis, was auf das Formular gedroppt wurde
     puffer : array [0 .. max_path] of char;
     i, j, p,
     Anzahl,
     laenge    : integer;
     max, flags : dword;
     t : tsearchrec;
     gefunden, linux : boolean;
     gefundenid : integer;
     v, vname : string;

begin (*
     // Feststellen, wieviele Files gedroppt werden
     // Es sind nur Verzeichnisse gültig und auch nur EINS !
     Anzahl := sizeof (filenames);

     if anzahl <> 1 then
     begin
          beep;
          showmessage ('Es ist nur EIN VERZEICHNIS zum Droppen gültig!');
          exit;
     end;

     // Jeden Dateinamen einzeln ermitteln bei mehreren Files!
     // In diesem Fall wird nur die erste Datei unterstützt - eine .TXT, die alle Angaben zum Film enthält

     auto.modus := automatisch;
     laenge := length (filenames [0]);
     dropname := stralloc (laenge);
     gefundenid := 0;

     // Prüfen, ob es sich um ein Verzeichnis handelt - nur dann gültig!
     if   verz_exist (dropname) then
     begin
          // Hier das Eigentliche mit dem Dateinamen machen
          // In diesem Fall das automatische Hinzufügen ermöglichen!

          // Verzeichnis bereinigen! media ... entfernen !

          linux := pos ('\media\', auto.lwname) > 0;

          if   linux then
          begin
               p := pos (':', auto.lwname);

               if   p > 0
               then auto.lwname := copy (auto.lwname, p + 2, 255);

               // in lwname steht jetzt media\Plattenname\Textdateiname - Plattennamen ermitteln
               // media entfernen
               p := pos ('\', auto.lwname);
               auto.lwname := copy (auto.lwname, succ (p), 255);
               // Textdateinamen entfernen, so daß der eigentliche Plattenname übrig bleibt
               p := pos ('\', auto.lwname);
               auto.lwname := copy (auto.lwname, succ (p), 255);
               vname := auto.lwname;
          end
          else vname := copy (dropname, 4, length (dropname));

          // Prüfen, ob ein Verzeichnis mit dieser Bezeichnung bereits in der DB vorhanden ist.
          // Falls ja, NICHT erneut aufnehmen (Doppelerfassung verhindern)
          // Allerdings NICHT im Korrigieren-Modus

          gefunden := false;

          if   funktion <> ff_korrigieren
          then for  j := 1 to recordcount do
               begin
                    lesen (j);

                    if   rec.Verz = vname then
                    begin
                         gefunden := true;
                         break;
                    end;
               end;

          if   gefunden then  // Verzeichnis schon vorhanden - nicht erneut aufnehmen!
          begin
               gefundenid := rec.ID;
               beep;
               showmessage ('Der Ordner ' + #13
                          + '»' + vname + '«' + #13
                          + 'existiert bereits in der Datenbank' + #13
                          + 'und ist dem Archiv »' + rec.HDName + '« zugewiesen!' + #13#13
                          + 'Die ID ist ' + inttostr (gefundenid));
          end else
          begin // Ordner in die Datenbank aufnehmen
               // TXT-Datei mit den Filminfos suchen
               auto.textdateiname := '';

               if   findfirst (dropname + '\*.TXT', faanyfile, t) = 0
               then auto.textdateiname := t.name
               else repeat
                    until findnext (t) <> 0;

               findclose (t);

               if   auto.textdateiname <> '' then
               begin
//                    GetVolumeInformation (PChar (auto.LW + ':'), puffer, sizeof(puffer), nil, max, Flags, nil, 0);
                    auto.lwname := puffer;
                    auto.verzeichnis := dropname;
                    auto.verzeichnis := copy (auto.verzeichnis, 4, 255);
                    auto.textdateiname := auto.lw + ':\' + auto.verzeichnis + '\'+ auto.textdateiname;

                    // Laufwerksbezeichnung anzeigen
                    ShowMessage ('LW: ' + auto.lw + #13
                               + 'LW-Name = ' + auto.lwname + #13
                               + 'Verzeichnis: = ' + auto.verzeichnis + #13
                               + 'Textdateiname: ' + auto.textdateiname);

                    timer1.enabled := true;
               end else
               begin
                    showmessage ('Keine *.TXT-Datei im Verzeichnis ' + #13
                               + dropname + #13
                               + 'gefunden!');
                    beep;
               end;
          end;
     end;

     strdispose (dropname);
     // Windows melden, daß der Drop-Vorgang beendet wurde
//     DragFinish (msg.WParam);*)
end;




function TFHinzufuegen.verzeichnis_groesse (v : string) : int64;

var
     g : int64;
     t : tsearchrec;
     uverz  : tstringlist; // Enthält alle gefundenen Unterverzeichnisse

label
     nochmal;

begin
     result := 0;
     g := 0;
     uverz := tstringlist.Create;

     // Jetzt alle Dateien in allen Unterverzeichnissen ermitteln
     // ohne .TXT und ohne Bild-Datei
nochmal:
     if   findfirst (v + '\*.*', faanyfile, t) = 0 then
     begin
          repeat
               // Ist der gefundene Dateiname ein . oder .. ignorieren
               if   (t.Name = '.')
               or   (t.name = '..')
               then // ignorieren
               else if   (t.Attr OR fadirectory) = t.attr // Es handelt sich um ein Unterverzeichnis
                    then uverz.Add (v + '\' + t.name)
                    else // Es handelt sich um einen Dateinamen, Größe einbeziehen, wenn nicht .TXT oder Bild
                    begin
                         if   (pos ('.TXT', uppercase (t.name)) > 0)
                         or   (pos ('.NFO', uppercase (t.name)) > 0)
                         or   (pos ('.JPG', uppercase (t.name)) > 0)
                         or   (pos ('.PNG', uppercase (t.name)) > 0)
                         or   (pos ('.GIF', uppercase (t.name)) > 0)
                         or   (pos ('.BMP', uppercase (t.name)) > 0)
                         or   (pos ('.TORRENT', uppercase (t.name)) > 0)
                         then
                         else g := g + dateigroesse (v + '\' + t.name);
                    end;
          until findnext (t) <> 0; // Dieser Ordner ist erledigt

          findclose (t);
     end;

     // Sind noch Unterordner abzusuchen?
     if   uverz.count > 0 then
     begin
          v := uverz [0];
          uverz.Delete (0);
          goto nochmal;
     end;

     uverz.Destroy;
     result := g;
end;




procedure TFHinzufuegen.ausfuellen; // Hier wird alles erledigt bei Drag & Drop

var
     j, p : integer;
     v, r : string;
     linux : boolean;

begin with auto do
begin
{
          modus : tmodus;
          lw,                         // Enthält den Laufwerksbuchstaben
          lwname : ansistring;        // Enthält die Laufwerksbezeichnung
          verzeichnis  : shortstring; // Enthält nur das Verzeichnis
          textdateiname: shortstring; // Enthält nur den Namen der .TXT}

     meinfo.Lines.LoadFromFile (txtname);
     tedatum.text := formatdatetime ('DD.MM.YYYY', filedatetodatetime (fileage (txtname)));

     // Prüfen, ob das Programm unter Windows oder Linux läuft

     linux := lwname = '';

{
showmessage ('lw: ' + lw + #13
          + 'lwname: ' + lwname + #13
          + 'verzeichnis: ' + verzeichnis + #13
          + 'textdateiname: ' + textdateiname);
}           (*
     if   linux then
     begin
          lwname := verzname;
          // in lwname steht jetzt media\Plattenname\Textdateiname - Plattennamen ermitteln
          // media entfernen
          p := pos ('\', lwname);
          lwname := copy (lwname, succ (p), 255);
          // Textdateinamen entfernen, so daß der eigentliche Plattenname übrig bleibt
          p := pos ('\', lwname);
          lwname := copy (lwname, 1, pred (p));

          // Aus dem verzeichnis /media/lw-bez entfernen
          v := '';
          p := 0;

          for j := 1 to length (verzeichnis)
          do   if p = 2
               then v := v + verzeichnis [j]
               else if verzeichnis [j] = '\'
                    then inc (p);

          verzeichnis := v;
     end;

     tehdname.text := lwname;

     // Format feststellen
     liformat.itemindex := pred (liformat.items.count);

     for  j := 0 to liformat.items.count - 2 do
     begin
          r := liformat.items [j];
          v := '(' + r + ')';

          if   j = 4
          then v := '(DivX)';

          if   pos (v, verzeichnis) > 0
          then if   j = 4
               then liformat.itemindex := 4
               else liformat.itemindex := liformat.Items.IndexOf (r);
     end;
{
ShowMessage ('für die verzeichnisgröße die werte: ' + #13
                                    + 'LW: ' + auto.lw + #13
                                    + 'LW-Name = ' + auto.lwname + #13
                                    + 'Verzeichnis: = ' + auto.verzeichnis + #13
                                    + 'Textdateiname: ' + auto.textdateiname);
}


     buautomatischclick (self);

     // um die Verzeichnisgröße ermitteln zu können muß ein gültiges (Linux-)Verzeichnis angegeben werden
     // dieses läßt sich aus dem textdateinamen extrahieren
showmessage (extractfilepath (textdateiname));
     rec.groesse := verzeichnis_groesse (extractfilepath (textdateiname));
     rec.Verz := verzeichnis;
     buokclick (self);
     close;   *)
end;
end;




procedure TFHinzufuegen.buAbbruchClick(Sender: TObject);
begin
(*
     if   activecontrol = buabbruch then
     begin
          modalresult := mrcancel;
          exit;
     end;
     
     if   messagedlg ('Wollen Sie wirklich abbrechen?', mtconfirmation, [mbyes, mbno], 0) = mrno
     then modalresult := mrnone
     else modalresult := mrcancel;
*)
end;

procedure TFHinzufuegen.buOKClick(Sender: TObject);
begin   (*
     // Eingaben auf Gültigkeit prüfen
     modalresult := mrnone;

     if   trim (tetitel.text) = '' then
     begin
          beep;
          showmessage ('Es wurde kein Titel eingegeben!');
          tetitel.setfocus;
          exit;
     end;

     try
          // Datum korrekt?
          tedatum.text := trim (tedatum.text);

          if   tedatum.text <> ''
          then rec.datum := strtodate (tedatum.text)
          else
          begin
               beep;
               showmessage ('Das Datum ist ungültig! (Leeres Feld)');
               tedatum.setfocus;
               exit;
          end;
     except
          beep;
          showmessage ('Das Datum ist ungültig! ' + #13#13 + 'Es lautet: ' + tedatum.text);
          tedatum.setfocus;
          exit;
     end;

     try
          // Jahr korrekt?
          tejahr.text := trim (tejahr.text);

          if   tejahr.text = ''
          then tejahr.text := '0';

          if   strtoint (tejahr.text) <> 0
          then; // nur um festzustellen, daß numerische Eingabe vorliegt !
     except
          beep;
          showmessage ('Das Jahr ist ungültig');
          tejahr.setfocus;
          exit;
     end;

     // Wurde ein Format ausgewählt?
     if   liformat.ItemIndex = -1 then
     begin
          beep;
          showmessage ('Es wurde kein Format ausgewählt!');
          liformat.setfocus;
          exit;
	end;  *)
end;

procedure TFHinzufuegen.FormShow(Sender: TObject);

begin
     boundsrect := us.EFPos;

     if   us.EFVollbild
     then windowstate := wsmaximized;
end;

procedure TFHinzufuegen.buImportierenClick(Sender: TObject);

var
     mpgname : string;

begin (*
     dlg.initialdir := txtverz;
     dlg.DefaultExt := '*.txt';
     dlg.Filter := 'Textdateien|*.txt';

     if   not dlg.execute
     then exit;

     meinfo.Lines.LoadFromFile (dlg.filename);
     meinfo.setfocus;

     // Dateidatum übernehmen
     try
          if   pos ('(VCD)', dlg.filename) > 1
          then mpgname := copy (dlg.filename, 1, length (dlg.filename) - 4) + ' (VCD).mpg'
          else mpgname := copy (dlg.filename, 1, length (dlg.filename) - 4) + ' (DivX).avi';

          tedatum.text := formatdatetime ('DD.MM.YYYY', filedatetodatetime (fileage (mpgname)));
     except
          // Hat nicht geklappt, also Datei manuell auswählen
          buDatumclick (self);
     end;

     if   pos ('(DivX)', mpgname) > 0
     then liformat.ItemIndex := 4; *)
end;

procedure TFHinzufuegen.buDatumClick(Sender: TObject);

var
     datum : string;

begin (*
     dlg.initialdir := txtverz;
     dlg.DefaultExt := '*.mpg';
     dlg.Filter := 'Videodateien|*.mpg;*.avi';

     if   not dlg.execute
     then exit;

     try
        datum := formatdatetime ('DD.MM.YYYY', filedatetodatetime (fileage (dlg.filename)))
     except
     end;

     tedatum.text := datum; *)
end;

procedure TFHinzufuegen.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
     if   key = vk_f9
     then tedatum.text := formatdatetime ('DD.MM.YYYY', date);

     if   key = vk_escape
     then buabbruchclick (self);

     if   (key = 65)        
     and  (shift = [ssalt]) then
     begin
          buabbruch.setfocus;
          buabbruchclick (self);
     end;
end;

procedure TFHinzufuegen.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin(*
     us.EFVollbild := windowstate = wsmaximized;
     windowstate := wsnormal;
     us.EFPos := boundsrect;
     closeaction := caHide;*)
end;

procedure TFHinzufuegen.buAutomatischClick(Sender: TObject);

var
     j, p : integer;
     l : tstringlist;
     h, s : ansistring;

begin  (*
     l := tstringlist.create;
     l.Assign (meinfo.Lines);

     try
          tetitel.text := l [0];
          s := l [3];
          h := '';

          for  j := 1 to length (s) do
          begin
               if   s [j] = ','
               then break
               else h := h + s [j];
          end;

          tegenre.text := h;

          j := 1;
          h := '';

          while j < length (s)
          do   if   s [j] in ['0' .. '9']
               then break
               else inc (j);

          h := copy (s, j, 4);
          tejahr.text := h;

          j := 7;

          while l [j] <> '' do
          begin
{               s := l [j];
               h := '';
               p := 1;

               while p <= length (s)
               do   if   s [p] in ['0' .. '9', 'A' .. 'Z', 'a' .. 'z', 'ß', 'Ä', 'ä', 'ö', 'Ö', 'ü', 'Ü', '-', ' ']
                    then inc (p)
                    else break;

               if   not (s [p] in ['0' .. '9', 'A' .. 'Z', 'a' .. 'z', 'ß', 'Ä', 'ä', 'ö', 'Ö', 'ü', 'Ü', '-', ' '])
               then dec (p);

               h := trim (copy (s, 1, p));}
               inc (j);
          end;

     finally
          l.free;
     end; *)
end;

procedure TFHinzufuegen.meInfoChange(Sender: TObject);

var
     zeichen : integer;

begin
     zeichen := length (meinfo.text);
     lainfogroesse.caption := floattostrf (zeichen, ffnumber, 4, 0)
                            + ' Zeichen (10.000 max.) - Rest: '
                            + floattostrf (10000 - zeichen, ffnumber, 4, 0);

     if   zeichen > 10000 then
     begin
          tiwarnung.enabled := true;
          lainfogroesse.font.color := rot;
     end else
     begin
          tiwarnung.enabled := false;
          lainfogroesse.font.color := schwarz;
          lainfogroesse.visible := true;
     end;
end;

procedure TFHinzufuegen.tiWarnungTimer(Sender: TObject);
begin
     lainfogroesse.visible := not lainfogroesse.visible;
end;

procedure TFHinzufuegen.Timer1Timer(Sender: TObject);
begin
     timer1.enabled := false;

     if   auto.modus = automatisch then
     begin
          ausfuellen;
          buokclick (self);
     end;
end;

end.

